--[[

   main.lua
   Daisy Moon initialization script. Initializes Because it's fun, Fay.
	
   Copyright 2008 Oxeye Game Studio. http://www.oxeyegames.com
	
   File contributors:
      Jens Bergensten

   This game was written for the TIGSource Procedural Generation
   competition in May 2008. You may use this Lua source code in
   any way you please, we don't mind. However, the game's sound
   effects and artwork belong to us, so please ask for permission
   before you do anything funny =)

]]

local daisy = daisy

math.randomseed( os.time() )

-- GLOBALS

singlePlayer = false
powerupSprites = {}
playerPowerups = { fay = { }, corn = { } }


dofile("game.lua")
dofile("menu.lua")
dofile("bossFight.lua")

local function startGame()

	-- load shared gfx
	powerupSprites.glow = daisy.createSpriteState("glow", "stuff.dat")
	powerupSprites.star = daisy.createSpriteState("star", "stuff.dat")
	powerupSprites[1] = daisy.createSpriteState("comb", "stuff.dat") -- atk
	powerupSprites[2] = daisy.createSpriteState("gecko", "stuff.dat") -- atk
	powerupSprites[3] = daisy.createSpriteState("hairDrier", "stuff.dat")
	powerupSprites[4] = daisy.createSpriteState("icecream", "stuff.dat") -- def
	powerupSprites[5] = daisy.createSpriteState("nesController", "stuff.dat") -- agi
	powerupSprites[6] = daisy.createSpriteState("oxeye", "stuff.dat") --
	powerupSprites[7] = daisy.createSpriteState("partyHat", "stuff.dat") -- mgk
	powerupSprites[8] = daisy.createSpriteState("pizzaSlice", "stuff.dat") -- life
	powerupSprites[9] = daisy.createSpriteState("pop", "stuff.dat") -- mana
	powerupSprites[10] = daisy.createSpriteState("starfish", "stuff.dat") -- mana
	powerupSprites[11] = daisy.createSpriteState("strawberries", "stuff.dat") -- life
	powerupSprites[12] = daisy.createSpriteState("syringe", "stuff.dat")
	powerupSprites[13] = daisy.createSpriteState("toiletRoll", "stuff.dat") -- def
	powerupSprites[14] = daisy.createSpriteState("vhsTape", "stuff.dat") -- mgk
	powerupSprites[15] = daisy.createSpriteState("yoyo", "stuff.dat") -- agi

	playerPowerups.getPowerupType = function(index)
		if index == 1 or index == 2 then
			return 1 -- attack
		elseif index == 4 or index == 13 then
			return 2 -- defense
		elseif index == 7 or index == 14 then
			return 3 -- magic
		elseif index == 8 or index == 11 then
			return 4 -- life
		elseif index == 10 or index == 9 then
			return 5 -- mana
		elseif index == 5 or index == 15 then
			return 6 -- agility
		end
		return -1 -- item
	end

	-- give each player 2 daisies
	table.insert(playerPowerups.fay, 6)
	table.insert(playerPowerups.fay, 6)
	table.insert(playerPowerups.corn, 6)
	table.insert(playerPowerups.corn, 6)
	
	-- test
	
	for i=1,50 do
		local type = math.random(1,15)
		while playerPowerups.getPowerupType(type) == -1 and math.random() > .5 do
			type = math.random(1,15)
		end
		--table.insert(playerPowerups.fay, type)

		type = math.random(1,15)
		while playerPowerups.getPowerupType(type) == -1 and math.random() > .5 do
			type = math.random(1,15)
		end
		--table.insert(playerPowerups.corn, type)
	end
	

	registerMenuState()
	--registerGameState()
	--registerBossFightState()
end
hook.add("gameInit", startGame)

